// Generated by ReScript, PLEASE EDIT WITH CARE
'use strict';

var Curry = require("rescript/lib/js/curry.js");
var Hashtbl = require("rescript/lib/js/hashtbl.js");
var Caml_option = require("rescript/lib/js/caml_option.js");

function fib(n) {
  if (n === 0 || n === 1) {
    return 1;
  } else {
    return fib(n - 1 | 0) + fib(n - 2 | 0) | 0;
  }
}

var cache = Hashtbl.create(undefined, 100);

function memofib(n) {
  var x = Hashtbl.find_opt(cache, n);
  if (x !== undefined) {
    return x;
  }
  var x$1 = fib(n);
  Hashtbl.replace(cache, n, x$1);
  return x$1;
}

function myfib(myfib$1, n) {
  if (n === 0 || n === 1) {
    return 1;
  } else {
    return Curry._1(myfib$1, n - 1 | 0) + Curry._1(myfib$1, n - 2 | 0) | 0;
  }
}

function memo(anyFunc) {
  var cache = Hashtbl.create(undefined, 100);
  var fix = function (n) {
    var x = Hashtbl.find_opt(cache, n);
    if (x !== undefined) {
      return Caml_option.valFromOption(x);
    }
    var x$1 = Curry._2(anyFunc, fix, n);
    Hashtbl.replace(cache, n, x$1);
    return x$1;
  };
  return fix;
}

var real_memofib = memo(myfib);

console.time("fib");

console.log(fib(42));

console.timeEnd("fib");

console.time("memofib");

console.log(memofib(42));

console.timeEnd("memofib");

console.time("real_memofib");

console.log(real_memofib(42));

console.timeEnd("real_memofib");

exports.fib = fib;
exports.memofib = memofib;
exports.myfib = myfib;
exports.memo = memo;
exports.real_memofib = real_memofib;
/* cache Not a pure module */
